Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ar.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ar.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ar.ts	(revision 19139)
@@ -7164,5 +7164,5 @@
     <message>
         <location filename="../ui/VBoxVMSettingsNetwork.ui" line="110"/>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="unfinished"></translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ca.ts	(revision 19139)
@@ -8080,5 +8080,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Controla la forma en què aquest adaptador virtual es connecta a la xarxa real del sistema amfitrió.</translation>
     </message>
@@ -9863,5 +9863,5 @@
     <message>
         <location filename="../ui/VBoxVMSettingsNetwork.ui" line="110"/>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Controla la forma en què aquest adaptador virtual es connecta a la xarxa real del sistema amfitrió.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_cs.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_cs.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_cs.ts	(revision 19139)
@@ -7665,5 +7665,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Ovládá způsob, jakým bude virtuální karta připojena k reálné síti hostitelského OS.</translation>
     </message>
@@ -9059,5 +9059,5 @@
     <message>
         <location filename="../ui/VBoxVMSettingsNetwork.ui" line="110"/>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Ovládá způsob, jakým bude virtuální karta připojena k reálné síti hostitelského OS.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 19139)
@@ -6395,5 +6395,5 @@
     <message>
         <location filename="../ui/VBoxVMSettingsNetwork.ui" line="110"/>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Legt fest, wie dieser virtuelle Netzwerkadapter an das physische Netzwerk des Host-Betriebssystems angeschlossen ist.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_el.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_el.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_el.ts	(revision 19139)
@@ -6335,5 +6335,5 @@
     <message>
         <location filename="../ui/VBoxVMSettingsNetwork.ui" line="110"/>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="unfinished"></translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_es.ts	(revision 19139)
@@ -8344,5 +8344,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Controla la manera en que este adaptador se conecta a la red real del Sist. Operativo Anfitrión.</translation>
     </message>
@@ -10022,5 +10022,5 @@
     <message>
         <location filename="../ui/VBoxVMSettingsNetwork.ui" line="110"/>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="unfinished">Controla la manera en que este adaptador se conecta a la red real del Sist. Operativo Anfitrión.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_eu.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_eu.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_eu.ts	(revision 19139)
@@ -7654,5 +7654,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Ostalari SE-ren sare errealera konektatzeko moldagailu birtualak modua kontrolatzen du.</translation>
     </message>
@@ -9181,5 +9181,5 @@
     <message>
         <location filename="../ui/VBoxVMSettingsNetwork.ui" line="110"/>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="unfinished">Ostalari SE-ren sare errealera konektatzeko moldagailu birtualak modua kontrolatzen du.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fi.ts	(revision 19139)
@@ -8669,5 +8669,5 @@
     <message>
         <location filename="../ui/VBoxVMSettingsNetwork.ui" line="110"/>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Määrittää, kuinka virtuaalinen verkkosovitin liitetään isäntäkoneen verkkoon.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_fr.ts	(revision 19139)
@@ -6044,5 +6044,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Contrôle la façon dont la carte virtuel accède au réseau physique de l&apos;ordinateur principal. </translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_hu.ts	(revision 19139)
@@ -6672,5 +6672,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Megadhathatod, hogyan legyen a virtuális adapter a valódi hálózathoz csatlakoztatva.</translation>
     </message>
@@ -8038,5 +8038,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Megadhathatod, hogyan legyen a virtuális adapter a valódi hálózathoz csatlakoztatva.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_id.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_id.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_id.ts	(revision 19139)
@@ -6854,5 +6854,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Mengendalikan cara adapter virtual ini terpasang pada jaringan Sistem Operasi Host yang sesungguhnya.</translation>
     </message>
@@ -8406,5 +8406,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="unfinished">Mengendalikan cara adapter virtual ini terpasang pada jaringan Sistem Operasi Host yang sesungguhnya.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_it.ts	(revision 19139)
@@ -7210,5 +7210,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Controlla la modalità secondo la quale questa scheda di rete virtuale è collegata alla rete reale del sistema Host.</translation>
     </message>
@@ -8847,5 +8847,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Controlla il modo in cui questa scheda di rete virtuale è collegata alla rete reale del sistema host.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ja.ts	(revision 19139)
@@ -6716,5 +6716,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">仮想アダプタをホストOSの実際のネットワークに割り当てる方式を指定します。</translation>
     </message>
@@ -8091,5 +8091,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>仮想アダプタをホストOSの実際のネットワークに割り当てる方式を指定します。</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_km_KH.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_km_KH.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_km_KH.ts	(revision 19139)
@@ -5207,5 +5207,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>ត្រួតពិនិត្យ​វិធី​ដែល​អាដាប់ទ័រ​និម្មិត​នេះ​ត្រូវ​បាន​ភ្ជាប់​ទៅ​បណ្ដាញ​ពិតប្រាកដ​របស់​ប្រព័ន្ធ​ប្រតិបត្តិការ​របស់​ម៉ាស៊ីន ។</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ko.ts	(revision 19139)
@@ -5110,5 +5110,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>이 어댑터가 호스트 운영체제의 실제 네트워크에 어떻게 연결되어 있는지를 제어합니다.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_nl.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_nl.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_nl.ts	(revision 19139)
@@ -5064,5 +5064,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="unfinished"></translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pl.ts	(revision 19139)
@@ -7012,5 +7012,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Decyduje o sposobie w jaki wirtualna karta sieciowa zostanie podłączona do rzeczywistej sieci w systemie operacyjnym gospodarza.</translation>
     </message>
@@ -8529,5 +8529,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Decyduje o sposobie w jaki wirtualna karta sieciowa zostanie podłączona do rzeczywistej sieci w systmie operacyjnym gospodarza.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt.ts	(revision 19139)
@@ -7111,5 +7111,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Controla a maneira como este adaptador virtual é ligado à rede real no sistema Hospedeiro.</translation>
     </message>
@@ -8748,5 +8748,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Controla a maneira como este adaptador virtual é ligado à rede real no sistema Hospedeiro.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_pt_BR.ts	(revision 19139)
@@ -7321,5 +7321,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Controla a maneira como este adaptador virtual é conectado à rede real no sistema Hospedeiro.</translation>
     </message>
@@ -8975,5 +8975,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Controla a maneira como este adaptador virtual é conectado à rede real no sistema Hospedeiro.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ro.ts	(revision 19139)
@@ -7488,5 +7488,5 @@
     </message>
     <message>
-        <source>Controls the way how this
+        <source>Controls how this
                                         virtual adapter is attached to the
                                         real network of the Host OS.</source>
@@ -7639,5 +7639,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Controlează modul în care această placă de rețea virtuală este atașată la rețeaua reală a SO gazdă.</translation>
     </message>
@@ -9387,5 +9387,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Controlează modul în care această placă de rețea virtuală este atașată la rețeaua reală a SO gazdă.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 19139)
@@ -5221,5 +5221,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Определяет способ, которым этот виртуальный сетевой адаптер подсоединяется к настоящей сети основной ОС.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sk.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sk.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sk.ts	(revision 19139)
@@ -7805,5 +7805,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="unfinished"></translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sr.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sr.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sr.ts	(revision 19139)
@@ -5212,5 +5212,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Контролише рад овог адаптера према праву мрежу хоста.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_sv.ts	(revision 19139)
@@ -5771,5 +5771,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>Kontrollerar sättet på hur den här virtuella adaptern anslutits till det verkliga nätverket för värdoperativsystemet.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_tr.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_tr.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_tr.ts	(revision 19139)
@@ -6691,5 +6691,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">Sanal bağdaştırıcının Sunucu İşletim Sisiteminin gerçek ağına nasıl bağlanacağını denetler.</translation>
     </message>
@@ -8092,5 +8092,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="unfinished">Sanal bağdaştırıcının Sunucu İşletim Sisiteminin gerçek ağına nasıl bağlanacağını denetler.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts	(revision 19139)
@@ -5045,5 +5045,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="unfinished"></translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_CN.ts	(revision 19139)
@@ -7158,5 +7158,5 @@
     </message>
     <message>
-        <source>Controls the way how this
+        <source>Controls how this
                                         virtual adapter is attached to the
                                         real network of the Host OS.</source>
@@ -7308,5 +7308,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">设置网络连接以何种方式接入到主机上的真实网络.</translation>
     </message>
@@ -9016,5 +9016,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation>设置网络连接以何种方式接入到主机上的真实网络.</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_zh_TW.ts	(revision 19139)
@@ -7473,5 +7473,5 @@
     </message>
     <message>
-        <source>Controls the way how this
+        <source>Controls how this
                                         virtual adapter is attached to the
                                         real network of the Host OS.</source>
@@ -7636,5 +7636,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="obsolete">控制此虛擬配接卡附掛到主端作業系統真實網路的方式。</translation>
     </message>
@@ -9259,5 +9259,5 @@
     </message>
     <message>
-        <source>Controls the way how this virtual adapter is attached to the real network of the Host OS.</source>
+        <source>Controls how this virtual adapter is attached to the real network of the Host OS.</source>
         <translation type="unfinished">控制此虛擬配接卡附掛到主端作業系統真實網路的方式。</translation>
     </message>
Index: /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsNetwork.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsNetwork.ui	(revision 19138)
+++ /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsNetwork.ui	(revision 19139)
@@ -108,5 +108,5 @@
        <widget class="QComboBox" name="mCbAttachmentType" >
         <property name="whatsThis" >
-         <string>Controls the way how this virtual adapter is attached to the real network of the Host OS.</string>
+         <string>Controls how this virtual adapter is attached to the real network of the Host OS.</string>
         </property>
        </widget>