Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h	(revision 19225)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h	(revision 19239)
@@ -25,4 +25,5 @@
 
 #include "COMDefs.h"
+#include "VBox/com/Guid.h"
 
 #include "VBoxGlobalSettings.h"
@@ -51,10 +52,10 @@
 {
 public:
-    VBoxMachineStateChangeEvent (const QUuid &aId, KMachineState aState)
+    VBoxMachineStateChangeEvent (const QString &aId, KMachineState aState)
         : QEvent ((QEvent::Type) VBoxDefs::MachineStateChangeEventType)
         , id (aId), state (aState)
         {}
 
-    const QUuid id;
+    const QString id;
     const KMachineState state;
 };
@@ -63,10 +64,10 @@
 {
 public:
-    VBoxMachineDataChangeEvent (const QUuid &aId)
+    VBoxMachineDataChangeEvent (const QString &aId)
         : QEvent ((QEvent::Type) VBoxDefs::MachineDataChangeEventType)
         , id (aId)
         {}
 
-    const QUuid id;
+    const QString id;
 };
 
@@ -74,10 +75,10 @@
 {
 public:
-    VBoxMachineRegisteredEvent (const QUuid &aId, bool aRegistered)
+    VBoxMachineRegisteredEvent (const QString &aId, bool aRegistered)
         : QEvent ((QEvent::Type) VBoxDefs::MachineRegisteredEventType)
         , id (aId), registered (aRegistered)
         {}
 
-    const QUuid id;
+    const QString id;
     const bool registered;
 };
@@ -86,10 +87,10 @@
 {
 public:
-    VBoxSessionStateChangeEvent (const QUuid &aId, KSessionState aState)
+    VBoxSessionStateChangeEvent (const QString &aId, KSessionState aState)
         : QEvent ((QEvent::Type) VBoxDefs::SessionStateChangeEventType)
         , id (aId), state (aState)
         {}
 
-    const QUuid id;
+    const QString id;
     const KSessionState state;
 };
@@ -101,5 +102,5 @@
     enum What { Taken, Discarded, Changed };
 
-    VBoxSnapshotEvent (const QUuid &aMachineId, const QUuid &aSnapshotId,
+    VBoxSnapshotEvent (const QString &aMachineId, const QString &aSnapshotId,
                        What aWhat)
         : QEvent ((QEvent::Type) VBoxDefs::SnapshotEventType)
@@ -110,6 +111,6 @@
     const What what;
 
-    const QUuid machineId;
-    const QUuid snapshotId;
+    const QString machineId;
+    const QString snapshotId;
 };
 
@@ -285,5 +286,5 @@
     bool trayIconInstall();
 #endif
-    QUuid managedVMUuid() const { return vmUuid; }
+    QString managedVMUuid() const { return vmUuid; }
 
     VBoxDefs::RenderMode vmRenderMode() const { return vm_render_mode; }
@@ -609,10 +610,10 @@
     { checkForAutoConvertedSettings (true); }
 
-    CSession openSession (const QUuid &aId, bool aExisting = false);
+    CSession openSession (const QString &aId, bool aExisting = false);
 
     /** Shortcut to openSession (aId, true). */
-    CSession openExistingSession (const QUuid &aId) { return openSession (aId, true); }
-
-    bool startMachine (const QUuid &id);
+    CSession openExistingSession (const QString &aId) { return openSession (aId, true); }
+
+    bool startMachine (const QString &id);
 
     void startEnumeratingMedia();
@@ -634,5 +635,5 @@
     void addMedium (const VBoxMedium &);
     void updateMedium (const VBoxMedium &);
-    void removeMedium (VBoxDefs::MediaType, const QUuid &);
+    void removeMedium (VBoxDefs::MediaType, const QString &);
 
     bool findMedium (const CMedium &, VBoxMedium &) const;
@@ -795,5 +796,5 @@
 
     /** Emitted when the media is removed using #removeMedia(). */
-    void mediumRemoved (VBoxDefs::MediaType, const QUuid &);
+    void mediumRemoved (VBoxDefs::MediaType, const QString &);
 
     /* signals emitted when the VirtualBox callback is called by the server
@@ -852,5 +853,5 @@
     VBoxUpdateDlg *mUpdDlg;
 
-    QUuid vmUuid;
+    QString vmUuid;
 
 #ifdef VBOX_GUI_WITH_SYSTRAY
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxMediaComboBox.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxMediaComboBox.h	(revision 19225)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxMediaComboBox.h	(revision 19239)
@@ -35,5 +35,5 @@
 public:
 
-    typedef QMap <QUuid, QUuid> BaseToDiffMap;
+    typedef QMap <QString, QString> BaseToDiffMap;
 
     VBoxMediaComboBox (QWidget *aParent);
@@ -42,10 +42,10 @@
     void repopulate();
 
-    QUuid id (int = -1) const;
+    QString id (int = -1) const;
     QString location (int = -1) const;
 
-    void setCurrentItem (const QUuid &aItemId);
+    void setCurrentItem (const QString &aItemId);
     void setType (VBoxDefs::MediaType aMediaType);
-    void setMachineId (const QUuid &aMachineId = QUuid());
+    void setMachineId (const QString &aMachineId = QString::null);
 
     void setShowDiffs (bool aShowDiffs);
@@ -59,5 +59,5 @@
     void mediumAdded (const VBoxMedium &);
     void mediumUpdated (const VBoxMedium &);
-    void mediumRemoved (VBoxDefs::MediaType, const QUuid &);
+    void mediumRemoved (VBoxDefs::MediaType, const QString &);
 
     void processActivated (int aIndex);
@@ -75,5 +75,5 @@
     void replaceItem (int, const VBoxMedium &);
 
-    bool findMediaIndex (const QUuid &aId, int &aIndex);
+    bool findMediaIndex (const QString &aId, int &aIndex);
 
     VBoxDefs::MediaType mType;
@@ -83,9 +83,9 @@
     {
         Medium() {}
-        Medium (const QUuid &aId, const QString &aLocation,
+        Medium (const QString &aId, const QString &aLocation,
                 const QString aToolTip)
             : id (aId), location (aLocation), toolTip (aToolTip) {}
 
-        QUuid id;
+        QString id;
         QString location;
         QString toolTip;
@@ -95,9 +95,9 @@
     Media mMedia;
 
-    QUuid mLastId;
+    QString mLastId;
 
     bool mShowDiffs : 1;
 
-    QUuid mMachineId;
+    QString mMachineId;
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxMediaManagerDlg.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxMediaManagerDlg.h	(revision 19225)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxMediaManagerDlg.h	(revision 19239)
@@ -52,10 +52,10 @@
                 bool aRefresh = true,
                 const CMachine &aSessionMachine = CMachine(),
-                const QUuid &aSelectId = QUuid(),
+                const QString &aSelectId = QString::null,
                 bool aShowDiffs = true);
 
     static void showModeless (QWidget *aParent = NULL, bool aRefresh = true);
 
-    QUuid selectedId() const;
+    QString selectedId() const;
     QString selectedLocation() const;
 
@@ -77,5 +77,5 @@
     void mediumAdded (const VBoxMedium &aMedium);
     void mediumUpdated (const VBoxMedium &aMedium);
-    void mediumRemoved (VBoxDefs::MediaType aType, const QUuid &aId);
+    void mediumRemoved (VBoxDefs::MediaType aType, const QString &aId);
 
     void mediumEnumStarted();
@@ -88,5 +88,5 @@
     void doReleaseMedium();
 
-    bool releaseMediumFrom (const VBoxMedium &aMedium, const QUuid &aMachineId);
+    bool releaseMediumFrom (const VBoxMedium &aMedium, const QString &aMachineId);
 
     void processCurrentChanged (int index = -1);
@@ -117,5 +117,5 @@
     void updateTabIcons (MediaItem *aItem, ItemAction aAction);
 
-    MediaItem* searchItem (QTreeWidget *aTree, const QUuid &aId) const;
+    MediaItem* searchItem (QTreeWidget *aTree, const QString &aId) const;
 
     bool checkMediumFor (MediaItem *aItem, Action aAction);
@@ -162,11 +162,11 @@
     /* Machine */
     CMachine mSessionMachine;
-    QUuid mSessionMachineId;
+    QString  mSessionMachineId;
     bool mHardDisksInaccessible;
     bool mDVDImagesInaccessible;
     bool mFloppyImagesInaccessible;
-    QUuid mHDSelectedId;
-    QUuid mDVDSelectedId;
-    QUuid mFloppySelectedId;
+    QString mHDSelectedId;
+    QString mDVDSelectedId;
+    QString mFloppySelectedId;
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxMedium.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxMedium.h	(revision 19225)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxMedium.h	(revision 19239)
@@ -135,5 +135,5 @@
     const CFloppyImage &floppyImage() const { return mFloppyImage; }
 
-    QUuid id() const { return mId; }
+    QString id() const { return mId; }
 
     QString location (bool aNoDiffs = false) const
@@ -179,5 +179,5 @@
      * current state.
      */
-    bool isAttachedInCurStateTo (const QUuid &aMachineId) const
+    bool isAttachedInCurStateTo (const QString &aMachineId) const
         { return mCurStateMachineIds.indexOf (aMachineId) >= 0; }
 
@@ -186,5 +186,5 @@
      * to in their current state (i.e. excluding snapshots).
      */
-    const QList <QUuid> &curStateMachineIds() const
+    const QList <QString> &curStateMachineIds() const
         { return mCurStateMachineIds; }
 
@@ -235,5 +235,5 @@
     CFloppyImage mFloppyImage;
 
-    QUuid mId;
+    QString mId;
     QString mLocation;
     QString mName;
@@ -250,5 +250,5 @@
     bool mIsUsedInSnapshots : 1;
 
-    QList <QUuid> mCurStateMachineIds;
+    QList <QString> mCurStateMachineIds;
 
     VBoxMedium *mParent;
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxSelectorWnd.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxSelectorWnd.h	(revision 19225)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxSelectorWnd.h	(revision 19239)
@@ -77,14 +77,14 @@
     void vmSettings (const QString &aCategory = QString::null,
                      const QString &aControl = QString::null,
-                     const QUuid & = QUuid_null);
-    void vmDelete (const QUuid & = QUuid_null);
-    void vmStart (const QUuid & = QUuid_null);
-    void vmDiscard (const QUuid & = QUuid_null);
-    void vmPause (bool, const QUuid & = QUuid_null);
-    void vmRefresh (const QUuid & = QUuid_null);
-    void vmShowLogs (const QUuid & = QUuid_null);
+                     const QString & = QString::null);
+    void vmDelete (const QString & = QString::null);
+    void vmStart (const QString & = QString::null);
+    void vmDiscard (const QString & = QString::null);
+    void vmPause (bool, const QString & = QString::null);
+    void vmRefresh (const QString & = QString::null);
+    void vmShowLogs (const QString & = QString::null);
 
     void refreshVMList();
-    void refreshVMItem (const QUuid &aID, bool aDetails,
+    void refreshVMItem (const QString &aID, bool aDetails,
                                           bool aSnapshots,
                                           bool aDescription);
@@ -189,5 +189,5 @@
 #ifdef VBOX_GUI_WITH_SYSTRAY
 
-Q_DECLARE_METATYPE(QUuid);
+Q_DECLARE_METATYPE(QString);
 
 class VBoxTrayIcon : public QSystemTrayIcon
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxSnapshotsWgt.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxSnapshotsWgt.h	(revision 19225)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxSnapshotsWgt.h	(revision 19239)
@@ -73,10 +73,10 @@
 
     void refreshAll (bool aKeepSelected = true);
-    SnapshotWgtItem* findItem (const QUuid &aSnapshotId);
+    SnapshotWgtItem* findItem (const QString &aSnapshotId);
     SnapshotWgtItem* curStateItem();
     void populateSnapshots (const CSnapshot &aSnapshot, QTreeWidgetItem *aItem);
 
     CMachine         mMachine;
-    QUuid            mMachineId;
+    QString          mMachineId;
     KSessionState    mSessionState;
     SnapshotWgtItem *mCurSnapshotItem;
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMListView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMListView.h	(revision 19225)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMListView.h	(revision 19239)
@@ -44,5 +44,5 @@
     QString name() const { return mName; }
     QIcon osIcon() const { return mAccessible ? vboxGlobal().vmGuestOSTypeIcon (mOSTypeId) : QPixmap (":/os_other.png"); }
-    QUuid id() const { return mId; }
+    QString id() const { return mId; }
 
     QString sessionStateName() const;
@@ -70,5 +70,5 @@
 
     /* Cached machine data (to minimize server requests) */
-    QUuid mId;
+    QString mId;
     QString mSettingsFile;
 
@@ -113,9 +113,9 @@
     void clear();
 
-    VBoxVMItem *itemById (const QUuid &aId) const;
+    VBoxVMItem *itemById (const QString &aId) const;
     VBoxVMItem *itemByRow (int aRow) const;
-    QModelIndex indexById (const QUuid &aId) const;
-
-    int rowById (const QUuid &aId) const;;
+    QModelIndex indexById (const QString &aId) const;
+
+    int rowById (const QString &aId) const;;
 
     void sort (Qt::SortOrder aOrder = Qt::AscendingOrder) { sort (0, aOrder); }
@@ -148,5 +148,5 @@
 
     void selectItemByRow (int row);
-    void selectItemById (const QUuid &aID);
+    void selectItemById (const QString &aID);
     void ensureSomeRowSelected (int aRowHint);
     VBoxVMItem * selectedItem() const;
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMSettingsCD.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMSettingsCD.h	(revision 19225)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMSettingsCD.h	(revision 19239)
@@ -65,5 +65,5 @@
     QIWidgetValidator *mValidator;
     QVector<CHostDVDDrive> mHostCDs;
-    QUuid mUuidIsoCD;
+    QString mUuidIsoCD;
     QRadioButton *mLastSelected;
 };
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMSettingsFD.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMSettingsFD.h	(revision 19225)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMSettingsFD.h	(revision 19239)
@@ -65,5 +65,5 @@
     QIWidgetValidator *mValidator;
     QVector<CHostFloppyDrive> mHostFDs;
-    QUuid mUuidIsoFD;
+    QString mUuidIsoFD;
     QRadioButton *mLastSelected;
 };
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMSettingsHD.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMSettingsHD.h	(revision 19225)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxVMSettingsHD.h	(revision 19239)
@@ -79,7 +79,7 @@
 public:
     DiskValue()
-        : id (QUuid())
+        : id (QString::null)
         , name (QString::null), tip (QString::null), pix (QPixmap()) {}
-    DiskValue (const QUuid &aId);
+    DiskValue (const QString &aId);
     DiskValue (const DiskValue &aOther)
         : id (aOther.id)
@@ -105,5 +105,5 @@
     }
 
-    QUuid   id;
+    QString id;
     QString name;
     QString tip;
@@ -382,6 +382,6 @@
 
     /* private functions */
-    QUuid getWithMediaManager (const QUuid &aInitialId = QUuid());
-    QUuid getWithNewHDWizard();
+    QString getWithMediaManager (const QString &aInitialId = QString::null);
+    QString getWithNewHDWizard();
     int maxNameLength() const;
     void prepareComboboxes();