Index: trunk/src/VBox/HostDrivers/Support/linux/Makefile
===================================================================
--- trunk/src/VBox/HostDrivers/Support/linux/Makefile	(revision 19454)
+++ trunk/src/VBox/HostDrivers/Support/linux/Makefile	(revision 19455)
@@ -35,4 +35,9 @@
 # While at it, warn about BUILD_* vars found to help with user problems.
 #
+ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
+ BUILD_TARGET_ARCH_DEF := amd64
+else
+ BUILD_TARGET_ARCH_DEF := x86
+endif
 ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
  $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
@@ -46,13 +51,11 @@
    BUILD_TARGET_ARCH := x86
   else
-   ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
-    BUILD_TARGET_ARCH := amd64
-   else
-    BUILD_TARGET_ARCH := x86
-   endif
-  endif
- endif
-else
- $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
+   BUILD_TARGET_ARCH := $(BUILD_TARGET_ARCH_DEF)
+  endif
+ endif
+else
+ ifneq ($(BUILD_TARGET_ARCH),$(BUILD_TARGET_ARCH_DEF))
+  $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
+ endif
 endif
 
@@ -64,5 +67,7 @@
  BUILD_TYPE := release
 else
- $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
+ ifneq ($(BUILD_TYPE),release)
+  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
+ endif
 endif
 
Index: trunk/src/VBox/HostDrivers/VBoxNetAdp/linux/Makefile
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetAdp/linux/Makefile	(revision 19454)
+++ trunk/src/VBox/HostDrivers/VBoxNetAdp/linux/Makefile	(revision 19455)
@@ -26,4 +26,9 @@
 # While at it, warn about BUILD_* vars found to help with user problems.
 #
+ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
+ BUILD_TARGET_ARCH_DEF := amd64
+else
+ BUILD_TARGET_ARCH_DEF := x86
+endif
 ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
  $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
@@ -37,13 +42,11 @@
    BUILD_TARGET_ARCH := x86
   else
-   ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
-    BUILD_TARGET_ARCH := amd64
-   else
-    BUILD_TARGET_ARCH := x86
-   endif
-  endif
- endif
-else
- $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
+   BUILD_TARGET_ARCH := $(BUILD_TARGET_ARCH_DEF)
+  endif
+ endif
+else
+ ifneq ($(BUILD_TARGET_ARCH),$(BUILD_TARGET_ARCH_DEF))
+  $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
+ endif
 endif
 
@@ -55,5 +58,7 @@
  BUILD_TYPE := release
 else
- $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
+ ifneq ($(BUILD_TYPE),release)
+  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
+ endif
 endif
 
Index: trunk/src/VBox/HostDrivers/VBoxNetFlt/linux/Makefile
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetFlt/linux/Makefile	(revision 19454)
+++ trunk/src/VBox/HostDrivers/VBoxNetFlt/linux/Makefile	(revision 19455)
@@ -26,4 +26,9 @@
 # While at it, warn about BUILD_* vars found to help with user problems.
 #
+ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
+ BUILD_TARGET_ARCH_DEF := amd64
+else
+ BUILD_TARGET_ARCH_DEF := x86
+endif
 ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
  $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
@@ -37,13 +42,11 @@
    BUILD_TARGET_ARCH := x86
   else
-   ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
-    BUILD_TARGET_ARCH := amd64
-   else
-    BUILD_TARGET_ARCH := x86
-   endif
-  endif
- endif
-else
- $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
+   BUILD_TARGET_ARCH := $(BUILD_TARGET_ARCH_DEF)
+  endif
+ endif
+else
+ ifneq ($(BUILD_TARGET_ARCH),$(BUILD_TARGET_ARCH_DEF))
+  $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
+ endif
 endif
 
@@ -55,5 +58,7 @@
  BUILD_TYPE := release
 else
- $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
+ ifneq ($(BUILD_TYPE),release)
+  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
+ endif
 endif
 
Index: trunk/src/VBox/HostDrivers/linux/Makefile
===================================================================
--- trunk/src/VBox/HostDrivers/linux/Makefile	(revision 19454)
+++ trunk/src/VBox/HostDrivers/linux/Makefile	(revision 19455)
@@ -34,4 +34,5 @@
 	    $(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxnetflt; \
 	    cp vboxnetflt/vboxnetflt.ko .; \
+	    echo; \
 	fi
 	@if [ -d vboxnetadp ]; then \
@@ -39,4 +40,5 @@
 	    $(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxnetadp; \
 	    cp vboxnetadp/vboxnetadp.ko .; \
+	    echo; \
 	fi
 